#!/bin/bash

infile=$1
outfile=$1".mod.xml"

# add version and root begin tags to beginning of input file
echo '<?xml version="1.0" encoding="ASCII"?>' > temp1
echo "<net>" >> temp1
cat temp1 $1  > temp2

# format information tags (end with />)
perl -pe 's/<Fmt\ (\w+)>/<Fmt\ Fmt="\1"\/>/'         temp2 | \
perl -pe 's/<Name\ (\w+)>/<Name\ Name="\1"\/>/'            | \
perl -pe 's/<Epoch\ (\n+)>/<Epoch\ Epoch="\1"\/>/'         | \

# format UgUn tag arguments of different name than tag
sed 's/<UgUn  *\([^ ]\{1,9\}\) *>/<UgUn UgUn="\1">/g'      | \

# format tags where tag and arg have same value
# word | space | integer
perl -pe 's/<(\w+) (\n+)>/<\1 \1="\2">/'                   | \
# word | space | word
perl -pe 's/<(\w+) (\w+)>/<\1 \1="\2">/'                   | \

# format tags with multiple args
awk '{ if ( $0 ~ /<Cg 0 Fm:Input>/ ) {
     printf( "%s\n", "<Cg Cg=\"0\" Fm=\"Input\">" );
     } else {
          print $0;
     }
}'                                                         | \
awk '{ if ( $0 ~ /<Cg 0 Fm:Hidden>/ ) {
     printf( "%s\n", "<Cg Cg=\"0\" Fm=\"Hidden\">" );
     } else {
          print $0;
     }
}'                                                         | \

# format multi row, multi are data
perl -p0e 's/(<Un>\n)(.*)/\1<Bias>\2<\/Bias>/g'            | \
perl -pe 's/(\d+) ([\d.-]+)/<C\1>\2<\/C\1>/ if /<Cn/../<\/Cn/'   > $outfile

# add root close tag to end of file
echo "</net>" >> $outfile

# cleanup
rm temp1 temp2
